package cn.javacoder.test_fastdfs;

import java.io.File;
import java.io.FileOutputStream;
import java.util.Arrays;

import org.csource.common.NameValuePair;
import org.csource.fastdfs.ClientGlobal;
import org.csource.fastdfs.ProtoCommon;
import org.csource.fastdfs.StorageClient;
import org.csource.fastdfs.StorageServer;
import org.csource.fastdfs.TrackerClient;
import org.csource.fastdfs.TrackerServer;

public class TestAppender {

	public static void main(String[] args) throws Exception {
		String configFileName = "src/main/resources/fdfs_client.conf";
		ClientGlobal.init(configFileName);
		TrackerClient tracker = new TrackerClient();
		TrackerServer trackerServer = tracker.getConnection();
		if (trackerServer != null) {
			StorageServer storageServer = null;
			StorageClient client = new StorageClient(trackerServer, storageServer);
			String[] fileNames = { "src/main/resources/images/aliyun120.jpg", 
					"src/main/resources/images/jiandaoyun120.jpg", 
					"src/main/resources/images/sspaas320.jpg",
					"src/main/resources/images/sspaas700.jpg",
					"src/main/resources/images/submail120.jpg"};

			String[] fileInfo = null;
			for (int index = 0; index < fileNames.length; index++) {
				if (index == 0) {
					fileInfo = client.upload_appender_file(fileNames[index], "tar", null);
					System.out.println(Arrays.asList(fileInfo));
				} else {
					int ret = client.append_file(fileInfo[0], fileInfo[1], fileNames[index]);
					System.out.println(Arrays.asList(ret));
				}
				File f = new File(fileNames[index]);
				org.csource.common.NameValuePair[] meta_list = new org.csource.common.NameValuePair[1];
				meta_list[0] = new org.csource.common.NameValuePair("file_size_" + index, ""
						+ f.length());
				client.set_metadata(fileInfo[0], fileInfo[1], meta_list, ProtoCommon.STORAGE_SET_METADATA_FLAG_MERGE);
			}
			
			File outDir = new File("src/main/resources/test_pic");
			long file_offset = 0;
			long file_size = 0;
			org.csource.common.NameValuePair[] metadata = client.get_metadata(fileInfo[0], fileInfo[1]);
			for (org.csource.common.NameValuePair pair : metadata) {
				System.out.println("name:" + pair.getName() + ", value:" + pair.getValue());
				file_size = Long.valueOf(pair.getValue());
				byte[] content = client.download_file(fileInfo[0], fileInfo[1], file_offset, file_size);
				file_offset += file_size;
				
				FileOutputStream img = new FileOutputStream(new File(outDir, pair.getName()+ ".jpg" ));
				img.write(content);
				img.close();
			}
			trackerServer.close();
		}
	}

}
